#include "eki_write.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _di_iki_write_eki_s_
  const f_string_static_t iki_write_program_name_s = macro_f_string_static_t_initialize_1(IKI_WRITE_program_name_s, 0, IKI_WRITE_program_name_s_length);
  const f_string_static_t iki_write_program_name_long_s = macro_f_string_static_t_initialize_1(IKI_WRITE_program_name_long_s, 0, IKI_WRITE_program_name_long_s_length);
#endif // _di_iki_write_eki_s_

#ifndef _di_iki_write_eki_setting_load_
  void iki_write_eki_setting_load(const f_console_arguments_t arguments, iki_write_main_t * const main) {

    if (!main) return;

    if (main->program.parameters.array[f_console_standard_parameter_copyright_e].result & f_console_result_found_e) return;
    if (main->program.parameters.array[f_console_standard_parameter_help_e].result & f_console_result_found_e) return;
    if (main->program.parameters.array[f_console_standard_parameter_version_e].result & f_console_result_found_e) return;

    f_number_unsigned_t index = 0;
    f_console_parameter_t * const content = &main->program.parameters.array[iki_write_parameter_content_e];

    if (main->program.parameters.array[iki_write_parameter_object_e].result & f_console_result_value_e) {
      f_console_parameter_t * const object = &main->program.parameters.array[iki_write_parameter_object_e];
      f_string_dynamicss_t * const objectss = &main->setting.objectss;

      objectss->used = 0;

      main->setting.state.status = f_memory_arrays_resize(object->values.used, sizeof(f_string_dynamics_t), (void **) &objectss->array, &objectss->used, &objectss->size, &f_string_dynamicss_delete_callback);

      if (F_status_is_error(main->setting.state.status)) {
        iki_write_print_error(&main->program.error, macro_iki_write_f(f_memory_arrays_resize));

        return;
      }

      f_number_unsigned_t at_content = 0;
      f_number_unsigned_t at_object = 0;

      // Construct the array without allocating any more memory by setting this as a static string (used > 0, size = 0).
      for (index = 0; at_object < object->values.used; ) {

        if (iki_write_signal_check(main)) return;

        main->setting.state.status = f_memory_array_increase(main->setting.state.step_small, sizeof(f_string_dynamic_t), (void **) &objectss->array[objectss->used].array, &objectss->array[objectss->used].used, &objectss->array[objectss->used].size);

        if (F_status_is_error(main->setting.state.status)) {
          iki_write_print_error(&main->program.error, macro_iki_write_f(f_memory_array_increase));

          return;
        }

        index = object->values.array[at_object];

        objectss->array[objectss->used].array[objectss->array[objectss->used].used].string = main->program.parameters.arguments.array[index].string;
        objectss->array[objectss->used].array[objectss->array[objectss->used].used].used = main->program.parameters.arguments.array[index].used;
        objectss->array[objectss->used].array[objectss->array[objectss->used].used].size = 0;
        ++objectss->array[objectss->used].used;

        if (++at_object >= object->locations.used || object->locations.array[at_object] > content->locations.array[at_content] || object->locations.array[at_object] == content->locations.array[at_content] && object->locations_sub.array[at_object] > content->locations_sub.array[at_content]) {
          main->setting.state.status = f_memory_array_increase(main->setting.state.step_small, sizeof(f_string_dynamics_t), (void **) &objectss->array, &objectss->used, &objectss->size);

          if (F_status_is_error(main->setting.state.status)) {
            iki_write_print_error(&main->program.error, macro_iki_write_f(f_memory_array_increase));

            return;
          }

          objectss->used++;
          ++at_content;


          if (at_object < object->values.used && at_content >= content->values.used) {
            iki_write_print_eki_error_objects_match_content(&main->program.error);

            main->setting.state.status = F_status_set_error(F_parameter);

            return;
          }
        }
      } // for

      main->setting.flag |= iki_write_main_flag_object_d;
    }
    else if (main->program.parameters.array[iki_write_parameter_object_e].result & f_console_result_found_e) {
      main->setting.state.status = F_status_set_error(F_parameter);

      fll_program_print_error_parameter_missing_value(&main->program.error, f_console_symbol_long_normal_s, iki_write_long_object_s);

      return;
    }

    if (main->program.parameters.array[iki_write_parameter_content_e].result & f_console_result_value_e) {
      main->setting.contents.used = 0;

      main->setting.state.status = f_memory_arrays_resize(content->values.used, sizeof(f_string_dynamic_t), (void **) &main->setting.contents.array, &main->setting.contents.used, &main->setting.contents.size, &f_string_dynamics_delete_callback);

      if (F_status_is_error(main->setting.state.status)) {
        iki_write_print_error(&main->program.error, macro_iki_write_f(f_memory_arrays_resize));

        return;
      }

      // Construct the array without allocating any more memory by setting this as a static string (used > 0, size = 0).
      for (index = 0; main->setting.contents.used < content->values.used; ) {

        if (iki_write_signal_check(main)) return;

        index = content->values.array[main->setting.contents.used];

        main->setting.contents.array[main->setting.contents.used].string = main->program.parameters.arguments.array[index].string;
        main->setting.contents.array[main->setting.contents.used].used = main->program.parameters.arguments.array[index].used;
        main->setting.contents.array[main->setting.contents.used++].size = 0;
      } // for

      main->setting.flag |= iki_write_main_flag_content_d;
    }
    else if (main->program.parameters.array[iki_write_parameter_content_e].result & f_console_result_found_e) {
      main->setting.state.status = F_status_set_error(F_parameter);

      fll_program_print_error_parameter_missing_value(&main->program.error, f_console_symbol_long_normal_s, iki_write_long_content_s);

      return;
    }
  }
#endif // _di_iki_write_eki_setting_load_

#ifdef __cplusplus
} // extern "C"
#endif
