#include "iki_write.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _di_iki_write_iki_s_
  const f_string_static_t iki_write_program_name_s = macro_f_string_static_t_initialize_1(IKI_WRITE_program_name_s, 0, IKI_WRITE_program_name_s_length);
  const f_string_static_t iki_write_program_name_long_s = macro_f_string_static_t_initialize_1(IKI_WRITE_program_name_long_s, 0, IKI_WRITE_program_name_long_s_length);
#endif // _di_iki_write_iki_s_

#ifndef _di_iki_write_iki_setting_load_
  void iki_write_iki_setting_load(const f_console_arguments_t arguments, iki_write_main_t * const main) {

    if (!main) return;

    if (main->program.parameters.array[f_console_standard_parameter_copyright_e].result & f_console_result_found_e) return;
    if (main->program.parameters.array[f_console_standard_parameter_help_e].result & f_console_result_found_e) return;
    if (main->program.parameters.array[f_console_standard_parameter_version_e].result & f_console_result_found_e) return;

    f_number_unsigned_t index = 0;

    if (main->program.parameters.array[iki_write_parameter_object_e].result & f_console_result_value_e) {
      f_number_unsigneds_t * const values = &main->program.parameters.array[iki_write_parameter_object_e].values;

      main->setting.objectss.used = 0;

      main->setting.state.status = f_memory_arrays_resize(values->used, sizeof(f_string_dynamics_t), (void **) &main->setting.objectss.array, &main->setting.objectss.used, &main->setting.objectss.size, &f_string_dynamicss_delete_callback);

      if (F_status_is_error(main->setting.state.status)) {
        iki_write_print_error(&main->program.error, macro_iki_write_f(f_memory_arrays_resize));

        return;
      }

      // Construct the array without allocating any more memory by setting this as a static string (used > 0, size = 0).
      for (index = 0; main->setting.objectss.used < values->used; ) {

        if (iki_write_signal_check(main)) return;

        main->setting.state.status = f_memory_arrays_resize(1, sizeof(f_string_dynamic_t), (void **) &main->setting.objectss.array[main->setting.objectss.used].array, &main->setting.objectss.array[main->setting.objectss.used].used, &main->setting.objectss.array[main->setting.objectss.used].size, &f_string_dynamics_delete_callback);

        if (F_status_is_error(main->setting.state.status)) {
          iki_write_print_error(&main->program.error, macro_iki_write_f(f_memory_arrays_resize));

          return;
        }

        index = values->array[main->setting.objectss.used];

        main->setting.objectss.array[main->setting.objectss.used].array[0].string = main->program.parameters.arguments.array[index].string;
        main->setting.objectss.array[main->setting.objectss.used].array[0].used = main->program.parameters.arguments.array[index].used;
        main->setting.objectss.array[main->setting.objectss.used].array[0].size = 0;
        main->setting.objectss.array[main->setting.objectss.used++].used = 1;
      } // for

      main->setting.flag |= iki_write_main_flag_object_d;
    }
    else if (main->program.parameters.array[iki_write_parameter_object_e].result & f_console_result_found_e) {
      main->setting.state.status = F_status_set_error(F_parameter);

      fll_program_print_error_parameter_missing_value(&main->program.error, f_console_symbol_long_normal_s, iki_write_long_object_s);

      return;
    }

    if (main->program.parameters.array[iki_write_parameter_content_e].result & f_console_result_value_e) {
      f_number_unsigneds_t * const values = &main->program.parameters.array[iki_write_parameter_content_e].values;

      main->setting.contents.used = 0;

      main->setting.state.status = f_memory_arrays_resize(values->used, sizeof(f_string_dynamic_t), (void **) &main->setting.contents.array, &main->setting.contents.used, &main->setting.contents.size, &f_string_dynamics_delete_callback);

      if (F_status_is_error(main->setting.state.status)) {
        iki_write_print_error(&main->program.error, macro_iki_write_f(f_memory_arrays_resize));

        return;
      }

      // Construct the array without allocating any more memory by setting this as a static string (used > 0, size = 0).
      for (index = 0; main->setting.contents.used < values->used; ) {

        if (iki_write_signal_check(main)) return;

        index = values->array[main->setting.contents.used];

        main->setting.contents.array[main->setting.contents.used].string = main->program.parameters.arguments.array[index].string;
        main->setting.contents.array[main->setting.contents.used].used = main->program.parameters.arguments.array[index].used;
        main->setting.contents.array[main->setting.contents.used++].size = 0;
      } // for

      main->setting.flag |= iki_write_main_flag_content_d;
    }
    else if (main->program.parameters.array[iki_write_parameter_content_e].result & f_console_result_found_e) {
      main->setting.state.status = F_status_set_error(F_parameter);

      fll_program_print_error_parameter_missing_value(&main->program.error, f_console_symbol_long_normal_s, iki_write_long_content_s);

      return;
    }
  }
#endif // _di_iki_write_iki_setting_load_

#ifdef __cplusplus
} // extern "C"
#endif
