/**
 * FLL - Level 3
 *
 * Project: IKI Write
 * API Version: 0.7
 * Licenses: lgpl-2.1-or-later
 *
 * Provides the common enumeration types.
 *
 * This is auto-included and should not need to be explicitly included.
 */
#ifndef _iki_write_common_enumeration_h
#define _iki_write_common_enumeration_h

#ifdef __cplusplus
extern "C" {
#endif

/**
 * The main program parameters.
 */
#ifndef _di_iki_write_parameter_e_
  enum {
    iki_write_parameter_content_e = f_console_standard_parameter_last_e,
    iki_write_parameter_double_e,
    iki_write_parameter_file_e,
    iki_write_parameter_grave_e,
    iki_write_parameter_object_e,
    iki_write_parameter_single_e,
    iki_write_parameter_wrap_e,
  }; // enum

  #define iki_write_console_parameter_t_initialize \
    { \
      macro_fll_program_console_parameter_standard_initialize, \
      \
      macro_f_console_parameter_t_initialize_3(iki_write_short_content_s, iki_write_long_content_s, 1, f_console_flag_normal_e), \
      macro_f_console_parameter_t_initialize_3(iki_write_short_double_s,  iki_write_long_double_s,  0, f_console_flag_normal_e), \
      macro_f_console_parameter_t_initialize_3(iki_write_short_file_s,    iki_write_long_file_s,    1, f_console_flag_normal_e), \
      macro_f_console_parameter_t_initialize_3(iki_write_short_grave_s,   iki_write_long_grave_s,   0, f_console_flag_normal_e), \
      macro_f_console_parameter_t_initialize_3(iki_write_short_object_s,  iki_write_long_object_s,  1, f_console_flag_normal_e), \
      macro_f_console_parameter_t_initialize_3(iki_write_short_single_s,  iki_write_long_single_s,  0, f_console_flag_normal_e), \
      macro_f_console_parameter_t_initialize_3(iki_write_short_wrap_s,    iki_write_long_wrap_s,    0, f_console_flag_normal_e), \
    }

  #define iki_write_parameter_total_d (f_console_parameter_state_type_total_d + 7)
#endif // _di_iki_write_parameter_e_

#ifdef __cplusplus
} // extern "C"
#endif

#endif // _iki_write_common_enumeration_h
