#include "../iki_write.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _di_iki_write_cache_delete_
  void iki_write_cache_delete(iki_write_cache_t * const cache) {

    if (!cache) return;

    f_memory_array_resize(0, sizeof(f_char_t), (void **) &cache->buffer.string, &cache->buffer.used, &cache->buffer.size);
    f_memory_array_resize(0, sizeof(f_char_t), (void **) &cache->content.string, &cache->content.used, &cache->content.size);
    f_memory_array_resize(0, sizeof(f_char_t), (void **) &cache->iki.string, &cache->iki.used, &cache->iki.size);

    f_memory_arrays_resize(0, sizeof(f_string_dynamic_t), (void **) &cache->objects.array, &cache->objects.used, &cache->objects.size, &f_string_dynamics_delete_callback);
  }
#endif // _di_iki_write_cache_delete_

#ifndef _di_iki_write_main_delete_
  void iki_write_main_delete(iki_write_main_t * const main) {

    if (!main) return;

    fll_program_data_delete(&main->program);

    iki_write_cache_delete(&main->cache);
    iki_write_setting_delete(&main->setting);
  }
#endif // _di_iki_write_main_delete_

#ifndef _di_iki_write_setting_delete_
  void iki_write_setting_delete(iki_write_setting_t * const setting) {

    if (!setting) return;

    f_memory_arrays_resize(0, sizeof(f_string_dynamic_t), (void **) &setting->contents.array, &setting->contents.used, &setting->contents.size, &f_string_dynamics_delete_callback);
    f_memory_arrays_resize(0, sizeof(f_string_dynamic_t), (void **) &setting->objectss.array, &setting->objectss.used, &setting->objectss.size, &f_string_dynamicss_delete_callback);
  }
#endif // _di_iki_write_setting_delete_

#ifdef __cplusplus
} // extern "C"
#endif
