/**
 * FLL - Level 3
 *
 * Project: IKI Write
 * API Version: 0.7
 * Licenses: lgpl-2.1-or-later
 *
 * Provides the print error functionality.
 *
 * This is auto-included and should not need to be explicitly included.
 */
#ifndef _iki_write_print_message_h
#define _iki_write_print_message_h

#ifdef __cplusplus
extern "C" {
#endif

/**
 * Print help.
 *
 * @param print
 *   The output structure to print to.
 *
 *   The print.custom is expected to be of type iki_write_main_t.
 *
 *   This does not alter print.custom.setting.state.status.
 */
#ifndef _di_iki_write_print_message_help_
  extern void iki_write_print_message_help(fl_print_t * const print);
#endif // _di_iki_write_print_message_help_

/**
 * Print standard parts of the help regarding notes.
 *
 * This is expected to be called as part of the help printing and does not perform any locking.
 *
 * @param print
 *   The output structure to print to.
 *
 *   The print.custom is expected to be of type iki_write_main_t.
 *
 *   This does not alter print.custom.setting.state.status.
 */
#ifndef _di_iki_write_print_message_help_note_
  extern void iki_write_print_message_help_note(fl_print_t * const print);
#endif // _di_iki_write_print_message_help_note_

#ifdef __cplusplus
} // extern "C"
#endif

#endif // _iki_write_print_message_h
